package com.ibm.oti.security;

/*
 * Licensed Materials - Property of IBM,
 *     Copyright IBM Corp. 1998, 2011  All Rights Reserved
 */

import java.security.AccessControlContext;
import java.security.AccessController;
import java.security.PrivilegedAction;

public class CheckedAccessControlContext {

	private static ContextCombine combine = null;

	/**
	 * This method should be called once and only once from AccessControlContext on initialization.
	 */
	public static void setCombiner(ContextCombine combiner) {
		if (combine == null) {
			combine = combiner;
		}
	}

	public static <T> T securityCheck(PrivilegedAction<T> action, AccessControlContext acc1, AccessControlContext acc2){
		if ((null == action) || (null == acc1) || (null == acc2)) {
			// K03bd = Argument must not be null
			throw new NullPointerException(com.ibm.oti.util.Msg.getString("K03bd")); //$NON-NLS-1$
		}
		return AccessController.doPrivileged(action, combine.combineDomains(acc1, acc2));
	}

	public static <T> T securityCheck(PrivilegedAction<T> action, AccessControlContext acc1){
		return CheckedAccessControlContext.securityCheck(action, AccessController.getContext(), acc1);
	}

}

